var path = require('path'),
fs = require('fs'),
scaffoldit = require('scaffoldit'),
exec = require('child_process').exec;

function exists(path) {
	try {
		fs.lstatSync(path);
		return true;
	} catch(e) {
		return false;
	}
}

exports.build = function(ops, callback) {
	

	ops._src = __dirname + '/project.tpl.sublime-project';
	ops._dest = ops.cwd + '/project.sublime-project';
	ops.path = ops.cwd.replace(process.env.HOME,'~');

	var bin = '/usr/local/bin/subl',
	app = '/Applications/Sublime Text 2.app/Contents/SharedSupport/bin/subl';
	
	if(!exists(app)) {
		console.error('You do not have Sublime 2 installed. It must be placed in the /Applications folder.'.red);
		return;
	}
	
	if(!exists(bin)) {
		console.log('adding sublime command line: %s', bin.bold);
		
		exec('ln -s "'+app+'" '+bin, function(err, stdout, stderr) {
		});
	}
	
	scaffoldit.toFile(ops, function() {
		
		console.log('Set %s command proj to "%s"'.grey, path.basename(ops.cwd).bold, "subl --project project.sublime-project".bold);

		ops.config.commands.proj = 'subl --project project.sublime-project';
		
		callback.apply(null, arguments);
	});
	
}