var fs = require('fs'),
Step = require('step'),
ini = require('ini'),
plugin = require('plugin');




exports.plugin = function(router) {

	var plugins = plugin.loader();

	plugins.factory(function(module, options, params) {
		return module;
	}).
	require(__dirname + '/default').
	require(__dirname + '/license').
	load();

	router.on({
		
		/**
		 */
		
		'collect project/command': function(req, res) {
			res.end({
				name: 'bootstrap',
				execute: function(data, callback) {
					
					var args = data.args,
					cwd = this.path(),
					ops = (args.shift() || '').split('+'),
					config = {},
					name = this.name();

					try	{

						config = ini.parse(fs.readFileSync(cwd + '/.cupboard','utf8'));
					} catch(e) {
					}

					config.commands = config.commands || {};



					var steps = [],
					buildOps = data;

					ops.forEach(function(op) {

						var scaffolder = plugins.plugin(op); 


						if(!scaffolder) {

							console.warn('Scaffolder "%s" does not exist'.red, op.bold);
							return;
						}

						steps.push(function(err, result) {

							buildOps.cwd = cwd;
							buildOps.config = config;
							buildOps.name = name;


							scaffolder.build(buildOps, this)
						});
					});

					steps.push(function(err, result) {

						fs.writeFileSync(cwd + '/.cupboard', ini.stringify(config));
						
						callback();
					})


					if(steps.length) Step.apply(null, steps);
				}
			});
		},
		
		
		
		/**
		 */
		
		
		
		/**
		 */
		
		'collect help/item': function(req, res) {
			res.end({
				commands: [ {
					
					command: 'bootstrap <proj> <type>',
					desc: 'Init bootstrap template against proj'
				} ],
				examples: [ {
					command: 'bootstrap my-proj sublime+node',
					desc: '  '
				} ]
			});
		}
		
		
	})
}
